VTK: vtkCellCentersPointPlacer Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkCellCentersPointPlacer Class Reference

Snaps points at the center of a cell. More...

`#include <vtkCellCentersPointPlacer.h>`

Inheritance diagram for vtkCellCentersPointPlacer:
[legend]
Collaboration diagram for vtkCellCentersPointPlacer:
[legend]

## Public Types
enum | { ParametricCenter = 0 , CellPointsMean , None }
Public Types inherited from vtkPointPlacer
typedef vtkObject | Superclass
| Standard methods for instances of this class. More...

## Public Member Functions
virtual void | AddProp (vtkProp *)
virtual void | RemoveViewProp (vtkProp *prop)
virtual void | RemoveAllProps ()
vtkTypeBool | HasProp (vtkProp *)
int | GetNumberOfProps ()
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double worldPos[3], double worldOrient[9]) override
| Given a renderer and a display position in pixel coordinates, compute the world position and orientation where this point will be placed. More...
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double refWorldPos[3], double worldPos[3], double worldOrient[9]) override
| Given a renderer, a display position, and a reference world position, compute the new world position and orientation of this point. More...
int | ValidateWorldPosition (double worldPos[3]) override
| Given a world position check the validity of this position according to the constraints of the placer. More...
int | ValidateDisplayPosition (vtkRenderer *, double displayPos[2]) override
| Given a display position, check the validity of this position. More...
int | ValidateWorldPosition (double worldPos[3], double worldOrient[9]) override
| Given a world position and a world orientation, validate it according to the constraints of the placer. More...
virtual vtkCellPicker * | GetCellPicker ()
| Get the Prop picker. More...
virtual void | SetMode (int)
| Modes to change the point placement. More...
virtual int | GetMode ()
| Modes to change the point placement. More...
Public Member Functions inherited from vtkPointPlacer
virtual int | UpdateWorldPosition (vtkRenderer *ren, double worldPos[3], double worldOrient[9])
| Given a current renderer, world position and orientation, update them according to the constraints of the placer. More...
virtual int | UpdateNodeWorldPosition (double worldPos[3], vtkIdType nodePointId)
| Give the placer a chance to update the node information, if any. More...
virtual int | UpdateInternalState ()
| Called by the representation to give the placer a chance to update itself. More...
virtual void | SetPixelTolerance (int)
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual int | GetPixelTolerance ()
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual void | SetWorldTolerance (double)
| Set/get the tolerance used when performing computations in world coordinates. More...
virtual double | GetWorldTolerance ()
| Set/get the tolerance used when performing computations in world coordinates. More...
vtkPointPlacer * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkCellCentersPointPlacer * | New ()
| Instantiate this class. More...
Static Public Member Functions inherited from vtkPointPlacer
static vtkPointPlacer * | New ()
| Instantiate this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkPointPlacer * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkCellCentersPointPlacer ()
| ~vtkCellCentersPointPlacer () override
Protected Member Functions inherited from vtkPointPlacer
| vtkPointPlacer ()
| ~vtkPointPlacer () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkPropCollection * | PickProps
vtkCellPicker * | CellPicker
int | Mode
Protected Attributes inherited from vtkPointPlacer
int | PixelTolerance
double | WorldTolerance
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkPointPlacer | Superclass
| Standard methods for instances of this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkCellCentersPointPlacer * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instances of this class. More...
vtkCellCentersPointPlacer * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instances of this class. More...

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Snaps points at the center of a cell.

vtkCellCentersPointPlacer is a class to snap points on the center of cells. The class has 3 modes. In the ParametricCenter mode, it snaps points to the parametric center of the cell (see vtkCell). In CellPointsMean mode, points are snapped to the mean of the points in the cell. In 'None' mode, no snapping is performed. The computed world position is the picked position within the cell.

Usage:
  The actors that render data and wish to be considered for placement by this placer are added to the list as
  placer->AddProp( actor );

See also
  vtkPointPlacer

Tests:
  vtkCellCentersPointPlacer (Tests)

Definition at line 41 of file vtkCellCentersPointPlacer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointPlacer vtkCellCentersPointPlacer::Superclass

Standard methods for instances of this class.

Definition at line 53 of file vtkCellCentersPointPlacer.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
ParametricCenter |
CellPointsMean |
None |

Definition at line 121 of file vtkCellCentersPointPlacer.h.

## Constructor & Destructor Documentation

## ◆ vtkCellCentersPointPlacer()

vtkCellCentersPointPlacer::vtkCellCentersPointPlacer | ( |  | ) |
| protected

## ◆ ~vtkCellCentersPointPlacer()

vtkCellCentersPointPlacer::~vtkCellCentersPointPlacer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkCellCentersPointPlacer* vtkCellCentersPointPlacer::New | ( |  | ) |
| static

Instantiate this class.

## ◆ IsTypeOf()

static vtkTypeBool vtkCellCentersPointPlacer::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instances of this class.

## ◆ IsA()

virtual vtkTypeBool vtkCellCentersPointPlacer::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instances of this class.

Reimplemented from vtkPointPlacer.

## ◆ SafeDownCast()

static vtkCellCentersPointPlacer* vtkCellCentersPointPlacer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instances of this class.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCellCentersPointPlacer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instances of this class.

Reimplemented from vtkPointPlacer.

## ◆ NewInstance()

vtkCellCentersPointPlacer* vtkCellCentersPointPlacer::NewInstance | ( |  | ) | const

Standard methods for instances of this class.

## ◆ PrintSelf()

void vtkCellCentersPointPlacer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instances of this class.

Reimplemented from vtkObject.

## ◆ AddProp()

virtual void vtkCellCentersPointPlacer::AddProp | ( | vtkProp * |  | ) |
| virtual

## ◆ RemoveViewProp()

virtual void vtkCellCentersPointPlacer::RemoveViewProp | ( | vtkProp * | prop | ) |
| virtual

## ◆ RemoveAllProps()

virtual void vtkCellCentersPointPlacer::RemoveAllProps | ( |  | ) |
| virtual

## ◆ HasProp()

vtkTypeBool vtkCellCentersPointPlacer::HasProp | ( | vtkProp * |  | ) |

## ◆ GetNumberOfProps()

int vtkCellCentersPointPlacer::GetNumberOfProps | ( |  | ) |

## ◆ ComputeWorldPosition() [1/2]

int vtkCellCentersPointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a renderer and a display position in pixel coordinates, compute the world position and orientation where this point will be placed.

This method is typically used by the representation to place the point initially. For the Terrain point placer this computes world points that lie at the specified height above the terrain.

Reimplemented from vtkPointPlacer.

## ◆ ComputeWorldPosition() [2/2]

int vtkCellCentersPointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | refWorldPos[3],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a renderer, a display position, and a reference world position, compute the new world position and orientation of this point.

This method is typically used by the representation to move the point.

Reimplemented from vtkPointPlacer.

## ◆ ValidateWorldPosition() [1/2]

int vtkCellCentersPointPlacer::ValidateWorldPosition | ( | double | worldPos[3] | ) |
| overridevirtual

Given a world position check the validity of this position according to the constraints of the placer.

Reimplemented from vtkPointPlacer.

## ◆ ValidateDisplayPosition()

int vtkCellCentersPointPlacer::ValidateDisplayPosition | ( | vtkRenderer * | ,
|  | double | displayPos[2]
| ) |  |
| overridevirtual

Given a display position, check the validity of this position.

Reimplemented from vtkPointPlacer.

## ◆ ValidateWorldPosition() [2/2]

int vtkCellCentersPointPlacer::ValidateWorldPosition | ( | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a world position and a world orientation, validate it according to the constraints of the placer.

Reimplemented from vtkPointPlacer.

## ◆ GetCellPicker()

virtual vtkCellPicker* vtkCellCentersPointPlacer::GetCellPicker | ( |  | ) |
| virtual

Get the Prop picker.

## ◆ SetMode()

virtual void vtkCellCentersPointPlacer::SetMode | ( | int |  | ) |
| virtual

Modes to change the point placement.

Parametric center picks the parametric center within the cell. CellPointsMean picks the average of all points in the cell. When the mode is None, the input point is passed through unmodified. Default is CellPointsMean.

## ◆ GetMode()

virtual int vtkCellCentersPointPlacer::GetMode | ( |  | ) |
| virtual

Modes to change the point placement.

Parametric center picks the parametric center within the cell. CellPointsMean picks the average of all points in the cell. When the mode is None, the input point is passed through unmodified. Default is CellPointsMean.

## Member Data Documentation

## ◆ PickProps

vtkPropCollection* vtkCellCentersPointPlacer::PickProps
| protected

Definition at line 134 of file vtkCellCentersPointPlacer.h.

## ◆ CellPicker

vtkCellPicker* vtkCellCentersPointPlacer::CellPicker
| protected

Definition at line 135 of file vtkCellCentersPointPlacer.h.

## ◆ Mode

int vtkCellCentersPointPlacer::Mode
| protected

Definition at line 136 of file vtkCellCentersPointPlacer.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkCellCentersPointPlacer.h